// Generated by CoffeeScript 1.8.0
var Container, evaluateType, getFullPath, getPath, isRelative;

Container = require('./container');

isRelative = function(path) {
  return path.indexOf('.') === 0;
};

getFullPath = function(path, basePath) {
  if (typeof window !== "undefined" && window !== null) {
    return path;
  } else if (isRelative(path)) {
    return [basePath, path].join('/');
  } else {
    return [basePath, 'node_modules', path].join('/');
  }
};

evaluateType = function(moduleConfig, module) {
  var path;
  if (moduleConfig.type != null) {
    return moduleConfig.type;
  }
  path = moduleConfig.require || moduleConfig;
  if (typeof module === 'function' && isRelative(path)) {
    return 'factory';
  } else {
    return 'value';
  }
};

getPath = function(moduleConfig) {
  if (typeof moduleConfig === 'string') {
    return moduleConfig;
  } else {
    return moduleConfig.require;
  }
};

module.exports = function(config, basePath, opts, parent) {
  var di, modules;
  if (opts == null) {
    opts = {};
  }
  if (config == null) {
    throw new TypeError('No configuration was provided for loadConfig');
  }
  di = new Container(opts, parent);
  modules = config.modules || {};
  Object.keys(modules).forEach(function(key) {
    var e, fullPath, module, moduleConfig, path, type;
    moduleConfig = modules[key];
    path = getPath(moduleConfig);
    fullPath = getFullPath(path, basePath);
    try {
      module = require(fullPath);
    } catch (_error) {
      e = _error;
      module = require(path);
    }
    type = evaluateType(moduleConfig, module);
    if (type === 'factory') {
      return di.factory(key, module);
    } else {
      return di.value(key, module);
    }
  });
  return di;
};
